#!/usr/bin/python

"""
$Log: asmconsts.py,v $
Revision 1.2  2007/09/05 16:11:53  joxean
Constants for AVR binaries

"""

AVAILABLE_CPUS = ["x86", "avr"]

IGNORE_INSTRUCTIONS = {}
IGNORE_INSTRUCTIONS["x86"] = ["REMOVETOIGNOREpush%ebp", "REMOVETOIGNOREmov%esp,%ebp", 
                                                        "REMOVETOIGNOREleave", "REMOVETOIGNOREret", "nop", "hlt"]

IGNORE_INSTRUCTIONS["avr"] = ["REMOVETOIGNOREpushr28", "REMOVETOIGNOREpushr29", "REMOVETOIGNOREret", "nop"]

# Mainly, gcc generated functions
IGNORE_FUNCTIONS = [ # The most common for x86
                                       "call_gmon_start", "_start", "__i686.get_pc_thunk.bx", 
                                       "__do_global_dtors_aux", "frame_dummy", "__libc_csu_init",
                                       "__libc_csu_fini", "__do_global_ctors_aux", "__do_global_dtors_aux",
                                       "__do_register_frame", "__do_deregister_frame",
                                       "__libc_do_global_destruction", "__icrt_terminate", "__icrt_init", 
                                       "__x86_jump_to_context",
                                       # The most common for avr
                                       "__bad_interrupt", ".do_clear_bss_start", ".do_clear_bss_loop",
                                       "__do_clear_bss", ".do_copy_data_start", ".do_copy_data_loop",
                                       "__do_copy_data", "__ctors_end", "__vectors", "__epilogue_restores__",
                                       "__prologue_saves__", "__udivmodsi4_ep", "__udivmodsi4_loop",
                                       "__udivmodsi4", "__mulhi3_exit", "__mulhi3_skip1", "__mulhi3_loop",
                                       "__mulhi3", ".memset_start", ".memset_loop", ".strnlen_loop", 
                                       ".strlen_P_loop", ".strcpy_loop", 
                                       ]

INTERESTING_INSTRUCTIONS = {}
INTERESTING_INSTRUCTIONS["x86"] = ["call*%", "jmp*%"]
INTERESTING_INSTRUCTIONS["avr"] = [] # FIX: I don't know :/ 

WARNING_CALLS = ["strcpy", "strncpy", "strcat", "strncat", "printf", "puts", "gets", "scanf", "wcscpy", "tcscpy", "mbscpy",
                                    "wcscat", "tcscat", "mbscat","wcsncat", "tcsncat", "mbsncat", "strccpy", "strcadd", "getts", "syslog",
                                    "strlen", "wcslen", "tcslen", "mbslen", "MultiByteToWideChar", "strecpy", "streadd", "strtrns",
                                    "chroot", "getenv", "SetSecurityDescriptorDacl", "recv"]

DOUBLE_CHECK_CALLS = ["malloc", "free"]
USER_CONTROLLED_DATA = {}
USER_CONTROLLED_DATA["x86"] = ["push%"]
USER_CONTROLLED_DATA["avr"] = ["pushr"]


FUNCTION_START = {}
FUNCTION_START["x86"] = ["push%ebp", "mov%esp,%ebp"]
FUNCTION_START["avr"] = ["pushr28", "pushr29"]

FUNCTION_END = {}
FUNCTION_END["x86"] = ["leave", "ret"]
FUNCTION_END["avr"] = ["popr29", "popr28", "ret"]

JUMP_INSTRUCTIONS = {}

CURRENT_CPU = "x86" # By default

