#!/usr/bin/python

"""
Module "promisc" for Inguma based in the Scapy's implementation
Copyright (c) 2007 Joxean Koret <joxeankoret@yahoo.es>

License is GPL
"""
import os
import sys
import time

sys.path.append("../")
sys.path.append("../../")
sys.path.append("../../../")

try:
    if os.name == "nt":
        from winscapy import *
    else:
        from scapy import *

    hasScapy = True
except:
    hasScapy = False

name = "isnated"
brief_description = "Check if the target's port is NATed"
type = "discover"

class CNated:
    target = "192.168.1.0/24"
    port = 0
    waitTime = 0
    timeout = 1
    exploitType = 1
    services = {}
    results = {}
    dict = None
    ret = False

    def addToDict(self, element, value):
        if value == None:
            return

        if self.dict is not None:
            if self.dict.has_key(element):
            
                for x in self.dict[element]:
                    if x == value:
                        return

                self.dict[element] += [value]
            else:
                self.dict[element] = [value]

    def isNatedPort(self, port):
        ttl = 0

        while 1:
            p = IP(dst=self.target, ttl=ttl)/ICMP()
            res = sr1(p, timeout = self.timeout)
            
            if res.type == 11:
                ttl += 1
            else:
                break

        hops = ttl
        ttl = 0

        while 1:
            p = IP(dst=self.target, ttl=ttl)/TCP(dport=int(port), flags="S")
            res = sr1(p, timeout = self.timeout)

            if res.proto == 1 and res.type == 11:
                ttl +=1
            else:
                break

        if ttl == hops:
            return False
        else:
            print "Hops to host (ICMP)", self.target, hops,"to port (TCP)", port, ttl
            return True

    def run(self):
        if hasScapy:
            if self.port == 0:
                if self.dict.has_key(self.target + "_ports"):
                    for port in self.dict[self.target + "_ports"]:
                        if self.isNatedPort(port):
                            print "Port", port, "is NATed"
                        else:
                            print "Port", port, "is NOT NATed"
            else:
                if self.isNatedPort(self.port):
                    print "Port", self.port, "is NATed"
                else:
                    print "Port", self.port, "is NOT NATed"

            return True
        else:
            print "No scapy support :("
            return False

    def printSummary(self):
        pass
