#!/usr/bin/python

import os
import sys
import random

try:
    if os.name == "nt":
        from winscapy import IP, TCP, sr, conf, getmacbyip, get_working_if, traceroute, TracerouteResult
    else:
        from scapy import IP, TCP, sr, conf, getmacbyip, get_working_if, traceroute, TracerouteResult
    
    bHasScapy = True
except:
    bHasScapy = False

name = "trace"
brief_description = "Trace a route to a host(s)"
type = "discover"

class CTraceroute:

    target = ""
    ports = [21, 22, 23, 80, 443, 135, 139, 445, 1521, 1526, 1531, 1541, 1551, 1561, 7777, 7999, 8000, 8001, 8002, 8888]
    sport = random.randint(1024, 65535)
    dport = 80
    hosts = {}
    timeout = 10
    iface = get_working_if()
    tcp = 1
    minttl = 1
    maxttl = 20
    exploitType = 0
    results = {}
    wizard = False
    packets = None
    dict = None

    def __ini__(self):
        conf.verb = 0

    def addToDict(self, element, value):
        if self.dict is not None:
            if self.dict.has_key(element):
            
                for x in self.dict[element]:
                    if x == value:
                        return

                self.dict[element] += [value]
            else:
                self.dict[element] = [value]

            print "Adding hop ", value

    def run(self):
        if not bHasScapy:
            print "No scapy support :("
            return False

        self.hosts = {}
        self.dict["hops"] = []

        if self.tcp == 1:
            a,b = sr(IP(dst=self.target, ttl=(self.minttl,self.maxttl))/TCP(sport=self.sport, dport=self.dport),
                 timeout=self.timeout, iface = self.iface, retry = 0)
        else:
            a,b = sr(IP(dst=self.target, ttl=(self.minttl,self.maxttl)), retry=0)

        a = TracerouteResult(a.res)
        self.packets = a
        
        start = 0
        for x in a:
            i = 0
            for y in x:
                if start == 0:
                    start = 1
                    self.hosts[len(self.hosts)+1] = y.src
                    self.addToDict("hops", y.src)
                    continue

                if i == 0:
                    i = 1
                    continue

                self.hosts[len(self.hosts)+1] = y.src
                self.addToDict("hop", y.src)

        try:
            self.hosts[len(self.hosts)+1] = y.src
            self.addToDict("hop", y.src)
        except:
            # Ugly hack
            pass

        self.results = self.hosts
        return True

    def printSummary(self):
        idx = 0
        prevHost = ""

        if self.wizard:
            res = raw_input("Show graph (y/n) [y]: ")
            
            if res == "" or res.lower() == "y":
                res = raw_input("Path to file (otherwise display using ImageMagick): ")
                res3d = raw_input("Graphic 3D (y/n)[n]?: ")

                if res == "":
                    if res3d == "y":
                        self.packets.trace3D()
                    else:
                        self.packets.graph()
                else:
                    if res3d == "y":
                        self.packets.trace3D(target="> " + str(res))
                    else:
                        self.packets.graph(target="> " + str(res))

                return True

        print
        print "Trace to target(s)"
        print "------------------"
        print

        for res in self.results:
            idx += 1
            
            if prevHost == "":
                prevHost = self.results[res]
            elif prevHost == self.results[res]:
                continue
            else:
                prevHost = self.results[res]

            print "Hop",idx,self.results[res]

        print

if __name__ == "__main__":
    import sys

    objTraceroute = CTraceroute()
    objTraceroute.target = "www.google.com"
    objTraceroute.tcp = 1
    objTraceroute.run()

    i = 0

    print "Trace to",objTraceroute.target

    for host in objTraceroute.hosts:
        i += 1
        print "Hop",i,objTraceroute.hosts[host]


