#!/usr/bin/python

"""
Module FTP Fuzzer for Inguma
Copyright (c) 2007 Joxean Koret <joxeankoret@yahoo.es>

License is GPL
"""

name = "example" # Name to register a command in the main shell. Should have more than 3 chars. and less than 12
brief_description = "Example module to implement new ones" # A brief description of the module
type = "gather" # The type of a module, currently, can only be 'gather', 'exploit', 'discover', 'fuzz' or 'brute'

class CExampleModule:
    """ The example module. The main class will always starts with the character "C". Any other class will be ignored """

    target = ""  # Main target
    port = 0 # Port to be used
    waitTime = 0 # Time to wait between step and step
    timeout = 1 # Default timeout
    exploitType = 1 # Type of exploit. Currently 0=discover, 1=gather, 2=exploit. Discouraged, it will be surely removed.
    services = {} # The services dictionary object. To be used internally if needed.
    results = {} # The results dictionary object. To be used internally if needed.
    dict = None # The dictionary object will all the pen-test's related stuff. Write here if you need to pass data to other modules.
    interactive = True # Launched in interactive mode?

    def addToDict(self, element, value):
        """ It's used to add data to the knowledge base to be used, i.e., by other modules """
        if value == None:
            return

        if self.dict is not None:
            if self.dict.has_key(element):
            
                for x in self.dict[element]:
                    if x == value:
                        return

                self.dict[element] += [value]
            else:
                self.dict[element] = [value]

    def run(self):
        """ This is the main entry point of the module """
        for service in self.services:
            print "Services",service,"Value",self.services[service]

        #print "Not yet implemented"

        return True

    def printSummary(self):
        """ If the method run of the module returns True printSummary will called after """
        pass
