#!/usr/bin/python

"""
Module Nmap Fingerprinting for Inguma
Copyright (c) 2007 Joxean Koret <joxeankoret@yahoo.es>

License is GPL
"""

import os
import sys

sys.path.append("lib")
sys.path.append("../lib")
sys.path.append("../../lib")

try:
    if os.name == "nt":
        import winscapy as scapy
    else:
        import scapy

    hasScapy = True
except:
    hasScapy = False

name = "nmapfp"
brief_description = "Os detect with Nmap fingerprinting"
type = "gather"

class CNmapFp:

    target = ""  # Main target
    port = 0 # Port to be used
    waitTime = 0 # Time to wait between step and step
    timeout = 1 # Default timeout
    exploitType = 1
    services = {}
    results = {}
    dict = None
    oport = 80
    cport = 81

    def addToDict(self, element, value):
        """ It's used to add data to the knowledge base to be used, i.e., by other modules """
        if value == None:
            return

        if self.dict is not None:
            if self.dict.has_key(element):
            
                for x in self.dict[element]:
                    if x == value:
                        return

                self.dict[element] += [value]
            else:
                self.dict[element] = [value]

    def run(self):
        if not hasScapy:
            print "[!] No scapy support :( "
            return False
        
        res = scapy.nmap_fp(target=self.target, oport = self.oport, cport = self.cport)
        self.accuracy = res[0]
        data = res[1]
        self.results = data

        return True

    def printSummary(self):
        print "Possible Operative System List"
        print "------------------------------"
        print
        for os in self.results:
            print "  " + os
        
        print 
        print 'Accuracy: %f' % (self.accuracy * 100) + " %"
        print
