#!/usr/bin/python

import sys
import time
import socket

name = "tcpscan"
brief_description = "Simple TCP port scanner"
type = "gather"

class CTCPScan:

    target = ""
    ports = [21, 22, 23, 80, 443, 135, 139, 445, 1521, 1524, 1526, 1531, 1541, 1551, 1561, 7777, 7999, 8000, 8001, 8002, 8888]
    waitTime = 0
    opened = {}
    closed = {}
    timeout = 1
    exploitType = 1
    services = {}
    results = {}
    interactive = True

    def addToDict(self, element, value):
        """ It's used to add data to the knowledge base to be used, i.e., by other modules """
        if value == None:
            return

        if self.dict is not None:
            if self.dict.has_key(element):
            
                for x in self.dict[element]:
                    if x == value:
                        return

                self.dict[element] += [value]
            else:
                self.dict[element] = [value]

    def run(self):
        for port in self.ports:
            try:
                socket.setdefaulttimeout(self.timeout)
                s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                s.connect((self.target, port))
                s.close()

                self.opened[port] = "open"
                self.addToDict(self.target + "_ports", port)

            except:
                self.closed[port] = "close"

        return True

    def printSummary(self):
        print
        print "Open ports"
        print "----------"
        print
        for opened in self.opened:
            try:
                port_name = socket.getservbyport(opened)
                port_name = str(opened) + "/" + port_name
            except:
                port_name = str(opened)

            print "Port",port_name,"is open"

        print
